"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.command = void 0;
const path_1 = require("path");
const revision_1 = require("../../revision");
const command = (config, db, dao, service, ...args) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    console.log('Listing revisions...');
    let currentRevision;
    yield db.transaction((client) => __awaiter(void 0, void 0, void 0, function* () {
        yield dao.initialize(client);
        currentRevision = yield service.fetchCurrentRevision(client, {
            namespace: config.revisionsNamespace
        });
    }));
    const revisionModules = (0, revision_1.loadDirectory)(config.revisionsDirectory);
    const currentRevisionModuleIndex = revisionModules.findIndex((revision) => revision.version === (currentRevision === null || currentRevision === void 0 ? void 0 : currentRevision.version));
    for (let index = 0; index < revisionModules.length; index++) {
        const revisionModule = revisionModules[index];
        const displayPreviousVersion = (_a = revisionModule.previousVersion) !== null && _a !== void 0 ? _a : '(base)';
        let displayVersion = revisionModule.version;
        if (index === currentRevisionModuleIndex) {
            displayVersion += ' (current)';
        }
        else if (index < currentRevisionModuleIndex) {
            displayVersion += ' (applied)';
        }
        else {
            displayVersion += ' (pending)';
        }
        const displayFile = (0, path_1.basename)(revisionModule.file);
        console.log('---');
        console.log(`index:    ${index}`);
        console.log(`previous: ${displayPreviousVersion}`);
        console.log(`version:  ${displayVersion}`);
        console.log(`file:     ${displayFile}`);
    }
});
exports.command = command;
