"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapBy = exports.groupBy = void 0;
const groupBy = (items, propertyOrFunction) => {
    return items.reduce((groupMap, item) => {
        var _a;
        const groupKey = typeof propertyOrFunction === 'string'
            ? item[propertyOrFunction]
            : propertyOrFunction(item);
        const groupArray = (_a = groupMap[groupKey]) !== null && _a !== void 0 ? _a : [];
        groupArray.push(item);
        groupMap[groupKey] = groupArray;
        return groupMap;
    }, {});
};
exports.groupBy = groupBy;
const mapBy = (items, propertyOrFunction, reduceFunction) => {
    const groupedAsArray = (0, exports.groupBy)(items, propertyOrFunction);
    const defaultReduceFunction = (groupMap, groupKey) => {
        const groupArray = groupedAsArray[groupKey];
        if (groupArray.length !== 1) {
            throw new Error(`map collision for given key "${String(groupKey)}"`);
        }
        groupMap[groupKey] = groupArray[0];
        return groupMap;
    };
    return Object.keys(groupedAsArray).reduce(reduceFunction !== null && reduceFunction !== void 0 ? reduceFunction : defaultReduceFunction, {});
};
exports.mapBy = mapBy;
