"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hashFile = exports.hash = exports.HashAlgorithm = void 0;
const fs_1 = require("fs");
const crypto_1 = require("crypto");
var HashAlgorithm;
(function (HashAlgorithm) {
    HashAlgorithm["SHA256"] = "sha256";
    HashAlgorithm["SHA1"] = "sha1";
    HashAlgorithm["MD5"] = "md5";
})(HashAlgorithm = exports.HashAlgorithm || (exports.HashAlgorithm = {}));
const hash = (content, algorithm) => {
    const hash = (0, crypto_1.createHash)(algorithm !== null && algorithm !== void 0 ? algorithm : HashAlgorithm.SHA1);
    hash.update(content);
    return hash.digest('hex');
};
exports.hash = hash;
const hashFile = (file, algorithm) => {
    const fileBuffer = (0, fs_1.readFileSync)(file);
    return (0, exports.hash)(fileBuffer, algorithm);
};
exports.hashFile = hashFile;
